# -*- coding: iso-8859-15 -*-

##################
# TP 5 : Graphes #
##################

class Matrice:
    # Cre une matrice de taille nxn dont tous les coefficient vallent d
    def __init__(self,n,d=0):
        self.n=n
        self.coeffs=[]
        for l in range(n):
            self.coeffs.append([d]*n)

    # Permet d'afficher la matrice avec print
    def __repr__(self):
        str=""
        for l in range(self.n):
            for c in range(self.n):
                str=str+repr(self.coeffs[l][c])+'\t'
            str=str+'\n'
        return str

    # Retourne la valeur du coefficient (l,c) avec 1<=l<=n et 1<=c<=n
    def lire(self,l,c):
        if l<1 or l>self.n or c<1 or c>self.n:
            raise AttributeError("Indices coefficient matrice invalides")
        return self.coeffs[l-1][c-1]

    # Affecte une valeur au coefficient (l,c) avec 1<=l<=n et 1<=c<=n
    def ecrire(self,l,c,v):
        if l<1 or l>self.n or c<1 or c>self.n:
            raise AttributeError("Indices coefficient matrice invalides")
        self.coeffs[l-1][c-1]=v

# Nous allons reprsent les
#  - graphes non orient
#  - graphes orient
# grce a leurs matrices d'ajacences.
# Ainsi lorsqu'on parlera du graph G, on supposera que G a la martice d'adjacence du grpahe G

#------------
# Exercice 1
#------------

# 1. Ecrire une fonction ajoute_arete(G,i,j) qui ajoute une arete i -- j dans le graphe non orient G

# 2. Ecrire une fonction ajoute_plusieurs_aretes(G,l) qui tant donne une liste de couple (i,j)
#    ajoute l'arete i -- j  G. Exemple : ajoulte_plusieurs_aretes(G,[(1,2),(4,3)])

# 3. Ecrire une fonction ajoute_arete_orientee(G,i,j) qui ajoute une arete i -> j dans le graphe orient G

# 4. Ecrire une fonction ajoute_plusieurs_aretes_orientee (G,l) qui tant donne une liste de couple (i,j)
#    ajoute l'arete i -> j  G. Exemple : ajoulte_plusieurs_aretes(G,[(1,2),(4,3)])

#------------
# Exercice 2
#------------

# Crer les graphes non orientes et orientes vus en cours et en TD

#------------
# Exercice 3
#------------

# 1. Ecrire une fonction degre(G,v) qui retourne le degre du sommet v du graphe non oriente G

# 2. Ecrire une fonction degre_entrant(G,v) qui retourne le degre entrant du sommet v du graphe oriente G

# 3. Ecrire une fonction degre_sortant(G,v) qui retourne le degre entrant du sommet v du graphe oriente G

# 4. Ecrire une fonction possede_chemin_eulerien(G) qui teste si le graphe connexe non oriente G
#    possede un chemin eulerien

# 5. Ecrire une fonction possede_chemin_eulerien_oriente(G) qui teste si le graphe connexe oriente G
#    possede un chemin eulerien

#-----------
# Exerice 4
#-----------

class File:
    def __init__(self):
        self.data=[]

    def empty(self):
        return len(self.data)==0

    def enfile(self, v):
        self.data.append(v);

    def defile(self):
        if not self.empty():
            x=self.data[0]
            self.data=self.data[1:]
            return x
        return None
    
class Pile:
    def __init__(self):
        self.data=[]

    def empty(self):
        return len(self.data)==0

    def enpile(self, v):
        self.data.append(v)

    def depile(self,v):
        if not self.empty():
            x=self.data[-1]
            self.data=self.data[:-1]
            return x
        return None

# 1. Ecrire ue fonction parcours_largeur(G,v) qui affiche les sommets de G visiter lors d'un parcours
#    en largeur du graphe G  partir du sommet v. Ici le graphe G est oriente ou non (l'alorithme est
#    le mme si  on est vigilant)

# 2. Ecrire ue fonction parcours_profondeur(G,v) qui affiche les sommets de G visiter lors d'un parcours
#    en profondeur du graphe G  partir du sommet v. Ici le graphe G est oriente ou non (l'alorithme est
#    le mme si  on est vigilant)

#------------
# Exercice 5
#------------

# Ecrire une fonction est_connexe(G) qui test si un graphe G oriente est connexe.




